// FileWriter.cpp: CFileWriter NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "FileWriter.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CFileWriter::CFileWriter()
	: IMediaDecoder()
	, m_llWriteSize(0U)
	, m_llWriteCount(0U)
{

}

CFileWriter::~CFileWriter()
{
	CloseFile();
}

void CFileWriter::Reset(void)
{
	m_OutFile.Seek(0U);

	m_llWriteSize = 0U;
	m_llWriteCount = 0U;
}

const DWORD CFileWriter::GetInputNum(void) const
{
	return 1UL;
}

const DWORD CFileWriter::GetOutputNum(void) const
{
	return 0UL;
}

const bool CFileWriter::InputMedia(CMediaData *pMediaData, const DWORD dwInputIndex)
{
	if(dwInputIndex > GetInputNum())return false;

	bool bReturn = false;

	// t@Cɏ
	if(m_OutFile.Write(pMediaData->GetData(), pMediaData->GetSize())){
		m_llWriteSize += pMediaData->GetSize();
		m_llWriteCount++;
		bReturn = true;
		}

	// ̓f[^폜
	pMediaData->Delete();

	return bReturn;
}

const bool CFileWriter::OpenFile(LPCTSTR lpszFileName)
{
	// t@CJ
	return (m_OutFile.Open(lpszFileName, CNCachedFile::CNF_WRITE | CNCachedFile::CNF_NEW))? true : false;
}

void CFileWriter::CloseFile(void)
{
	// t@C
	m_OutFile.Close();
}

const LONGLONG CFileWriter::GetWriteSize(void) const
{
	// ݍς݃TCYԂ
	return m_llWriteSize;
}

const LONGLONG CFileWriter::GetWriteCount(void) const
{
	// ݉񐔂Ԃ
	return m_llWriteCount;
}
