// MediaQueue.h: CMediaQueue NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#pragma once


#include "IMediaDecoder.h"
#include <queue>


using std::queue;


/////////////////////////////////////////////////////////////////////////////
// fBAL[(CMediaDataL[COĔ񓯊Ɏoi񋟂)
/////////////////////////////////////////////////////////////////////////////
// Input	#0	: CMediaData		̓f[^
/////////////////////////////////////////////////////////////////////////////

#define MAXQUEUECOUNT	10UL

class CMediaQueue : public IMediaDecoder  
{
public:
	CMediaQueue();
	virtual ~CMediaQueue();

// IMediaDecoder
	virtual void Reset(void);

	virtual const DWORD GetInputNum(void) const;
	virtual const DWORD GetOutputNum(void) const;

	virtual const bool InputMedia(CMediaData *pMediaData, const DWORD dwInputIndex = 0UL);

// CMediaQueue
	void EnableQueuing(const DWORD dwMaxQueueCount = MAXQUEUECOUNT);
	void DisableQueuing(void);

	CMediaData * PeekMediaData(void);
	CMediaData * GetMediaData(void);

	void PurgeMediaData(void);

protected:
	queue<CMediaData *> m_MediaQueue;
	DWORD m_dwMaxQueueCount;

	CRITICAL_SECTION m_CriticalSection;
	HANDLE m_hMediaEvent;

	bool m_bIsQueuing;
	bool m_bIsPreCharge;
};
