#pragma once


#include "BonSrcDecoder.h"
#include "TsPacketParser.h"
#include "TsDescrambler.h"
#include "TsDemuxer.h"		// b
#include "MediaViewer.h"


class CDtvEngine
{
public:
	CDtvEngine(void);
	~CDtvEngine(void);

	const bool OpenEngine(HWND hHostHwnd);
	const bool CloseEngine(void);
	const bool ResetEngine(void);
	
	const bool SetChannel(const BYTE byTuningSpace, const WORD wChannel);
	
	const bool EnablePreview(const bool bEnable = true);
	
	const DWORD GetLastError(void) const;

//protected:
	// IMediaDecoder hfBAfR[_NX
	CBonSrcDecoder m_BonSrcDecoder;
	CTsPacketParser m_TsPacketParser;
	CTsDescrambler m_TsDescrambler;
	CTsDemuxer m_TsDemuxer;
	CMediaViewer m_MediaViewer;	
};
